
PShape nozzle, box, shaft;

void initGL(){
  
  nozzle = loadShape("Model/bender_nozzle.obj");
  box = loadShape("Model/bender_box.obj");
  shaft = loadShape("Model/bender_shaft.obj");
  
  box.setFill(color(255,120,120));
  
  noStroke();
}

void transformCamera(){
  translate(width/2,height/2);
  if(debug) drawAxis();
  rotateX(rotY);
  rotateY(rotX); 
  scale(zoom); 
}

void drawGL(){
  pushMatrix();
  
  ortho();
  lights();
  smooth();
  
  transformCamera();
  
  drawMachine();
  drawWire();
  
  popMatrix();
}


void drawAxis(){
  strokeWeight(5);
  stroke(255);
  point(0,0);
  
  strokeWeight(2);
  stroke(255,0,0);
  line(0, 0, 30, 0);
  stroke(0,255,0);
  line(0, 0, 0, 30);
  stroke(0,0,255);
  line(0, 0, 0, 0,0,30);
}

void drawShape(PShape model){
  if(debug) drawAxis();
  shape(model);
}


void drawMachine(){
  shape(nozzle);
 
  drawShape(box);
  
  pushMatrix();
  rotateZ(shaftpos);
  translate(25,0,-20);
  drawShape(shaft);
  popMatrix();

}


void drawWire(){
  rotateX(currentAngle * DEG_TO_RAD);
  rotateZ(currentBend * DEG_TO_RAD);
  
  if(currentAngle < actual.GetRotation()){
    currentAngle += speedAngle;
    if(currentAngle >= actual.GetRotation()) currentAngle = actual.GetRotation();
  }
  
  if(currentAngle > actual.GetRotation()){
    currentAngle -= speedAngle;
    if(currentAngle <= actual.GetRotation()) currentAngle = actual.GetRotation();
  }

  if(currentBend < actual.GetAngle()){
    currentBend += speedAngle;
    if(currentBend >= actual.GetAngle()) currentBend = actual.GetAngle();
  }

  if(currentBend > actual.GetAngle()){
    currentBend -= speedAngle;
    if(currentBend <= actual.GetAngle()) currentBend = actual.GetAngle();
  }
  
  strokeWeight(3);
  stroke(180,50,50);
  pushMatrix();
 
  for (int counter = bendlist.size() - 1 ; counter >=0; counter--) {
    Bend current = bendlist.get(counter);
    rotateX(current.GetRotation() * DEG_TO_RAD);
    rotateZ(current.GetAngle()* DEG_TO_RAD);
    
    line(0, 0, current.GetLength(), 0);
    translate( current.GetLength(), 0);
    
  }
  
  popMatrix();
}
